cda.participant = {}

---------------------------------------------------------------------------------------------------------------------
-- All functions in cda.participant accept an <encounterParticipant>, <participantRole>, or <participant> element. --
---------------------------------------------------------------------------------------------------------------------

-- Default precision is 3 (YYYYMMDD)
function cda.participant.setTime(P, FuzzyTime, Precision)
   local T = imp.getOrCreateElement(P, 'time')
   return cda.util.date.setDate(T, FuzzyTime, Precision)
end

-- Use cda.header.assigned functions with the return value
function cda.participant.addAssignedEntity(P, Root, Extension)
   return imp.createChildWithId(P, 'assignedEntity', Root, Extension)
end

-- Use cda.header.associated functions with the return value
function cda.participant.addAssociatedEntity(P, ClassCode, Code, DisplayName)
   local AE = P:append(xml.ELEMENT, 'associatedEntity')
   AE:setAttr('classCode', ClassCode)
   local C = AE:append(xml.ELEMENT, 'code')
   C:setAttr('code', Code)
   C:setAttr('displayName', DisplayName)
   cda.codesystem.set(C, cda.cs.RoleCodePersonal)
   return AE
end

function cda.participant.addPlayingEntity
(
   P, ClassCode, Code, CodeSystem, DisplayName, ReferenceValue
)
   local PE = P:append(xml.ELEMENT, 'playingEntity')
   PE:setAttr('classCode', ClassCode)
   local C = cda.entry.addCode(PE, Code, CodeSystem, DisplayName)
   cda.entry.code.addOriginalTextReference(C, ReferenceValue)
   PE:append(xml.ELEMENT, 'name'):setText(DisplayName)
   return PE
end
